<script setup lang="ts">
import { ref,nextTick } from 'vue'

import { type Product } from '@/types/Product'
import { type ReceiptItem } from '@/types/ReceiptItem'

import ProductList from '@/components/ProductList.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import MemberCard from './MemberCard.vue'
import ReceiptDialog from './ReceiptDialog.vue'

import { useReceiptStore } from '@/stores/receipt'
import { provide } from 'vue'

const dialog = ref(false)
provide('receiptDialog',dialog)

const receiptStore = useReceiptStore()

const products1: Product[] = [
  { id: 1, name: 'ลาเต้ ร้อน', price: 35.0, type: 1 },
  { id: 2, name: 'ลาเต้ เย็น', price: 45.0, type: 1 },
  { id: 3, name: 'อเมริกาโน ร้อน', price: 55.0, type: 1 },
  { id: 4, name: 'อเมริกาโน เย็น', price: 60.0, type: 1 },
  { id: 5, name: 'ชาไทย ร้อน', price: 45.0, type: 1 },
  { id: 6, name: 'ชาไทย เย็น', price: 50.0, type: 1 },
  { id: 7, name: 'ชาเขียว ร้อน', price: 30.0, type: 1 },
  { id: 8, name: 'ชาเขียว เย็น', price: 40.0, type: 1 },
  { id: 9, name: 'กาแฟดำ ร้อน', price: 60.0, type: 1 }
]
const products2: Product[] = [
  { id: 1, name: 'ลาเต้ ร้อน', price: 35.0, type: 2 },
  { id: 2, name: 'ลาเต้ เย็น', price: 45.0, type: 2 }
]
const products3: Product[] = [
  { id: 1, name: 'ลาเต้ ร้อน', price: 35.0, type: 3 },
  { id: 2, name: 'ลาเต้ เย็น', price: 45.0, type: 3 },
  { id: 3, name: 'อเมริกาโน ร้อน', price: 55.0, type: 3 }
]

const selected = (p: Product) => {
  console.log('POS' + p)
  receiptStore.addReceiptItem(p)
  nextTick(() => {
    if (divRecieptItem.value) divRecieptItem.value.scrollTo(0, divRecieptItem.value.scrollHeight)
  })
  
}

const tab = ref(1)

const divRecieptItem = ref<HTMLElement | null>(null)

// function showReceipt() {
//   receiptStore.showReceiptDialog()
// }

</script>

<template>
  <v-container>
    <v-row
      ><v-col cols="12" md="6">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <div ref="divRecieptItem" style="height=300; overflow: auto">
                <v-sheet min-width="300" max-width="600" height="300" elevation="6" border>
                  <ReceiptDetailTable></ReceiptDetailTable>
                </v-sheet>
              </div>
            </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="600" height="80" elevation="6">
                <MemberCard></MemberCard>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="600" height="100" elevation="6">
                <ReceiptCard></ReceiptCard>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="600" height="80" elevation="6">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-btn block rounded="xl" size="large" color="red" @click="receiptStore.clear()">ยกเลิก</v-btn>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-btn block rounded="xl" size="large" color="green" @click="receiptStore.showReceiptDialog()">ชำระเงิน</v-btn>
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
      <v-col cols="12" md="6"
        ><v-sheet min-width="300" max-width="600" height="600" elevation="6">
          <v-tabs v-model="tab" color="deep-purple-accent-4" align-tabs="center">
            <v-tab :value="1">เครื่องดื่ม</v-tab>
            <v-tab :value="2">ขนม</v-tab>
            <v-tab :value="3">นํ้า</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="products1" @selectedProduct="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="products2" @selectedProduct="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="products3" @selectedProduct="selected"></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>
    </v-row>
  </v-container>
  <ReceiptDialog></ReceiptDialog>
</template>

<style scoped></style>
